local frame = CreateFrame("FRAME");
frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");

local _,currentRace = UnitRace("player");
local makeCampID = 312370;
local returnToCampID = 312372;

-- Saves the camp location when Make Camp is used.
frame:SetScript("OnEvent", function(event, ...)
    local _, source, _, spellID = ...;
    if ((source == "player") and (spellID == makeCampID)) then
        local subzone = GetMinimapZoneText();
        local zone = GetZoneText();
        if (subzone == zone) then
            campLocation = "somewhere in " .. zone;
        else
            campLocation = "at " .. subzone .. ", " .. zone;
        end;
    end;
end )

-- Appends camp location to Make Camp and Return to Camp spells.
local function ShowCampsite(tooltip, ...)
        local _,spellID = GameTooltip:GetSpell();
        if (spellID == makeCampID or spellID == returnToCampID) then
            if (campLocation == nil) then
                tooltip:AddLine("You seem to have forgotten\nwhere you last went camping...\n");
            else
                tooltip:AddLine("Your campsite is located\n" .. campLocation .. ".\n");
            end;
        end;
end;

if (currentRace == "Vulpera") then  -- Just in case :)
    GameTooltip:HookScript("OnTooltipSetSpell", ShowCampsite);
end;